#ifndef _TPR_TYPES_HPP_
#define _TPR_TYPES_HPP_

#include <vector>

namespace tpr {

enum class CommandType {
	pid_conf,
	temp_set,
	wait_temp,
	wait_time,
	temp_ramp,
	beep,
	temp_off,
	clear_flags,
	digio_conf,
	digio_set,
	digio_wait,
};

struct CommandSpec {
	CommandType type;
	std::vector<bool> param_is_whole_num;
};

class TprCommand {
private:
	static const CommandSpec m_specs[11];

	CommandType m_type;
	std::vector<float> m_parameters;
	bool is_whole_number(float num) const;

public:
	TprCommand(CommandType type);
	TprCommand(CommandType type, const std::vector<float> &params);
	TprCommand(CommandType type, const std::vector<float> &&params);
	

	bool check_command(bool print_status) const;
};


}

#endif /* _TPR_TYPES_HPP_ */